.\"	$NetBSD: link.2,v 1.22 2004/05/13 10:20:58 wiz Exp $
.\"
.\" Copyright (c) 1980, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)link.2	8.3 (Berkeley) 1/12/94
.\"
.Dd January 12, 1994
.Dt LINK 2
.Os
.Sh NAME
.Nm link
.Nd make a hard file link
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In unistd.h
.Ft int
.Fn link "const char *name1" "const char *name2"
.Sh DESCRIPTION
The
.Fn link
function call
atomically creates the specified directory entry (hard link)
.Fa name2
with the attributes of the underlying object pointed at by
.Fa name1 .
If the link is successful: the link count of the underlying object
is incremented;
.Fa name1
and
.Fa name2
share equal access and rights
to the
underlying object.
.Pp
If
.Fa name1
is removed, the file
.Fa name2
is not deleted and the link count of the
underlying object is
decremented.
.Pp
.Fa name1
must exist for the hard link to
succeed and
both
.Fa name1
and
.Fa name2
must be in the same file system.
.Fa name1
may not be a directory unless the caller is the super-user
and the file system containing it supports linking to directories.
.Sh RETURN VALUES
Upon successful completion, a value of 0 is returned.
Otherwise, a value of \-1 is returned and
.Va errno
is set to indicate the error.
.Sh ERRORS
.Fn link
will fail and no link will be created if:
.Bl -tag -width Er
.It Bq Er ENOTDIR
A component of either path prefix is not a directory.
.It Bq Er ENAMETOOLONG
A component of a pathname exceeded
.Dv {NAME_MAX}
characters, or an entire path name exceeded
.Dv {PATH_MAX}
characters.
.It Bq Er ENOENT
A component of either path prefix does not exist.
.It Bq Er EACCES
A component of either path prefix denies search permission, or
the requested link requires writing in a directory with a mode
that denies write permission.
.It Bq Er ELOOP
Too many symbolic links were encountered in translating one of the pathnames.
.It Bq Er ENOENT
The file named by
.Fa name1
does not exist.
.It Bq Er EOPNOTSUPP
The file system containing the file named by
.Fa name1
does not support links.
.It Bq Er EMLINK
The link count of the file named by
.Fa name1
would exceed
.Dv {LINK_MAX} .
.It Bq Er EEXIST
The link named by
.Fa name2
does exist.
.It Bq Er EPERM
The file named by
.Fa name1
is a directory and the effective
user ID is not super-user,
or the file system containing the file does not permit the use of
.Fn link
on a directory.
.It Bq Er EXDEV
The link named by
.Fa name2
and the file named by
.Fa name1
are on different file systems.
.It Bq Er ENOSPC
The directory in which the entry for the new link is being placed
cannot be extended because there is no space left on the file
system containing the directory.
.It Bq Er EDQUOT
The directory in which the entry for the new link
is being placed cannot be extended because the
user's quota of disk blocks on the file system
containing the directory has been exhausted.
.It Bq Er EIO
An I/O error occurred while reading from or writing to
the file system to make the directory entry.
.It Bq Er EROFS
The requested link requires writing in a directory on a read-only file
system.
.It Bq Er EFAULT
One of the pathnames specified
is outside the process's allocated address space.
.El
.Sh SEE ALSO
.Xr symlink 2 ,
.Xr unlink 2
.Sh STANDARDS
The
.Fn link
function conforms to
.St -p1003.1-90 .
